/***
 * Cecilia ADL Compiler
 * Copyright (C) 2006-2007 STMicroelectronics
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@objectweb.org
 *
 * Author: Matthieu Leclercq
 */

package org.objectweb.fractal.cecilia.adl.factories;

import org.objectweb.fractal.adl.components.ComponentContainer;
import org.objectweb.fractal.cecilia.adl.components.PrimitiveComponentCompiler;
import org.objectweb.fractal.task.codegen.api.RequireSourceCodeProviderTask;
import org.objectweb.fractal.task.core.TaskMap;

/**
 * Adds a task for the definition of the implemetation of the factory interface
 * of a component.
 */
public class FactoryComponentCompiler extends PrimitiveComponentCompiler {

  @Override
  protected void createTask(ComponentContainer container, TaskMap tasks,
      String controller, String implementation) {
    CreateTask task = new CreateTask(builderItf, controller, implementation);
    TaskMap.TaskHole t = addTask("component", task, container, tasks);
    
    TaskMap.TaskHole compDef = tasks.getTaskHole("component.definition",
        container);
    compDef.addDependency(t,
        RequireSourceCodeProviderTask.SOURCE_CODE_PROVIDER_TASK_ROLE, "factory");
  }
}
