/***
 * Cecilia ADL Compiler
 * Copyright (C) 2006-2007 STMicroelectronics
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@objectweb.org
 *
 * Author: Matthieu Leclercq
 */

package org.objectweb.fractal.cecilia.adl.implementations;

import java.util.Map;

/** Builder for component implementation. */
public interface ImplementationBuilder {

  /**
   * @param componentType the type of the component.
   * @param contentDesc the description of the content part of the component.
   * @param controllerDesc the description of the control part of the component.
   * @param codePieces the code pieces that as been produced by builders this
   *          builder depends on.
   * @param context additional parameters.
   * @return the code produced by this builder.
   * @throws Exception if something wrong append.
   */
  Object defineImplementation(Object componentType, Object contentDesc,
      Object controllerDesc, Map<String, Object> codePieces,
      Map<Object, Object> context) throws Exception;
}
